"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransactionInterceptor = void 0;
const common_1 = require("@nestjs/common");
const rxjs_1 = require("rxjs");
const typeorm_1 = require("@nestjs/typeorm");
const core_1 = require("@nestjs/core");
const typeorm_als_constants_1 = require("./typeorm-als.constants");
const operators_1 = require("rxjs/operators");
const async_hooks_1 = require("async_hooks");
const typeorm_als_utils_1 = require("./typeorm-als.utils");
let TransactionInterceptor = class TransactionInterceptor {
    constructor(reflector, moduleRef, asyncStorage) {
        this.reflector = reflector;
        this.moduleRef = moduleRef;
        this.asyncStorage = asyncStorage;
    }
    intercept(context, next) {
        return __awaiter(this, void 0, void 0, function* () {
            const options = this.reflector.get(typeorm_als_constants_1.TRANSACTIONAL_OPTIONS, context.getHandler());
            const connectionToken = typeorm_1.getConnectionToken(options === null || options === void 0 ? void 0 : options.connection);
            const connection = yield this.moduleRef.get(connectionToken, {
                strict: false,
            });
            const queryRunner = connection.createQueryRunner();
            yield queryRunner.connect();
            yield queryRunner.startTransaction(options === null || options === void 0 ? void 0 : options.isolation);
            const store = this.asyncStorage.getStore();
            typeorm_als_utils_1.setEntityManager(store, options, queryRunner.manager);
            return next.handle().pipe(operators_1.mergeMap((res) => {
                return rxjs_1.from(queryRunner.commitTransaction()).pipe(operators_1.mapTo(res));
            }), operators_1.catchError((err) => {
                return rxjs_1.from(queryRunner.rollbackTransaction()).pipe(operators_1.mergeMapTo(rxjs_1.throwError(err)));
            }), operators_1.finalize(() => {
                typeorm_als_utils_1.deleteEntityManager(store, options);
                return rxjs_1.from(queryRunner.release());
            }));
        });
    }
};
TransactionInterceptor = __decorate([
    common_1.Injectable(),
    __param(2, common_1.Inject(typeorm_als_constants_1.ASYNC_STORAGE)),
    __metadata("design:paramtypes", [core_1.Reflector,
        core_1.ModuleRef,
        async_hooks_1.AsyncLocalStorage])
], TransactionInterceptor);
exports.TransactionInterceptor = TransactionInterceptor;
